﻿Imports System.Text
Imports System.Numerics
Imports System.Globalization

Module Module2

    Public Function Test1() As Integer
        Dim bfs As Byte() = getBytesFromString("Hello, World!")
        If bfs.Length <> 13 Then Return 10
        Dim x As Byte() = {72, 101, 108, 108, 111, 44, 32, 87, 111, 114, 108, 100, 33}
        For i = 0 To 12
            If bfs(i) <> x(i) Then Return 11
        Next
        bfs = getBytesFromString("Привет, Мир!")
        If bfs.Length <> 21 Then Return 12
        If bfs(0) <> 208 Then Return 13
        If bfs(1) <> 159 Then Return 14
        If bfs(12) <> 44 Then Return 15
        If bfs(13) <> 32 Then Return 16
        If bfs(14) <> 208 Then Return 17
        If bfs(15) <> 156 Then Return 18
        If bfs(20) <> 33 Then Return 19
        Return 0
    End Function

    Public Function Test2() As Integer
        Dim bfs1 As Byte() = getBytesFromString("The quick brow")
        Dim bfs2 As Byte() = getBytesFromString("n fox jumps ov")
        Dim bfs3 As Byte() = getBytesFromString("er the lazy dog")
        Dim hash As Byte() = {&H37, &HF3, &H32, &HF6, &H8D, &HB7, &H7B, &HD9, &HD7, &HED, &HD4, &H96, &H95, &H71, &HAD, &H67, &H1C, &HF9, &HDD, &H3B}
        Dim x As Byte() = getHashFrom3BytesArrays(bfs1, bfs2, bfs3)
        If x.Length <> 20 Then Return 20
        For i As Integer = 0 To 19
            If x(i) <> hash(i) Then Return 21
        Next
        Return 0
    End Function

    Public Function Test3() As Integer
        Dim n As BigInteger = 2
        n = BigInteger.Pow(n, 160)
        n -= getBigIntFromHash({&HFF, &HFF, &HFF, &HFF, &HFF, &HFF, &HFF, &HFF, &HFF, &HFF, &HFF, &HFF, &HFF, &HFF, &HFF, &HFF, &HFF, &HFF, &HFF, &HFF})
        If n.IsOne Then Return 0
        Return 30
    End Function

    Public Function Test4() As Integer
        Dim n As BigInteger = New BigInteger(1234567890123456)
        If divideAndGetRemainder(n) <> 54 Then Return 40
        If n.Equals(19912385324571) Then Return 0
        Return 41
    End Function

    Public Function Test5() As Integer
        Dim x As String = "0123456789ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz"
        Dim sb As StringBuilder = New StringBuilder(62)
        For i As Integer = 0 To 61
            sb.Append(getSymbolByIndex(i))
        Next
        If x.Equals(sb.ToString) Then Return 0
        Return 50
    End Function

    Public Function Test6() As Integer
        Dim n As BigInteger = BigInteger.Parse("0132072df690933835eb8b6ad0b77e7b6f14acad7", NumberStyles.HexNumber)
        If n.Sign = -1 Then Return 60
        n = BigInteger.Remainder(n, 62)
        Dim pw As String = getPassWordFrom3Strings("The quick brown fox jumps over the lazy cog", "", "")
        If pw.IndexOf(getSymbolByIndex(CInt(n))) = 0 Then Return 0
        Return 61
    End Function

End Module
